/*
  Copyright (C) MOXA Inc. All rights reserved.
  This software is distributed under the terms of the
  MOXA License.  See the file COPYING-MOXA for details.
*/

// udpclientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "udpclient.h"
#include "udpclientDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define		IDT_SENDDATA	1001
#define		IDT_RECVDATA	1002

#define		SENDERR		0x01
#define		RECVERR		0x02
#define		ENDTHRD		0x04

UINT	SendPrg(LPVOID pParam);
UINT	RecvPrg(LPVOID pParam);

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUdpclientDlg dialog

CUdpclientDlg::CUdpclientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUdpclientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUdpclientDlg)
	m_count = _T("1");
	m_port = _T("4000");
	m_senddata = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_ipvar = 0;
	m_connectflag = 0;
	m_paravar.butflag = 0;
	char	temp[10];
	wsprintf(temp,"%s",m_count);
	m_paravar.count = atol(temp);
	m_paravar.dataidx = 0;
	m_paravar.flag = 0;	
	m_defultdata = "abcdefghij0123456789";
	m_paravar.sendcnt = 0;
	m_paravar.recvcnt = 0;
	m_paravar.predit = NULL;
}

void CUdpclientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUdpclientDlg)
	DDX_Control(pDX, IDC_SERIP, m_serip);
	DDX_Text(pDX, IDC_COUNT, m_count);
	DDV_MaxChars(pDX, m_count, 2);
	DDX_Text(pDX, IDC_PORT, m_port);
	DDV_MaxChars(pDX, m_port, 4);
	DDX_Text(pDX, IDC_SENDDATA, m_senddata);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUdpclientDlg, CDialog)
	//{{AFX_MSG_MAP(CUdpclientDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SENDBUT, OnSendbut)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUdpclientDlg message handlers

BOOL CUdpclientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_serip.SetAddress(m_ipvar);
	UpdateButton();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CUdpclientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
		if (nID == 61536) {
			m_paravar.flag |= ENDTHRD;
			closesocket(m_sock);
			Sleep(100);
			CDialog::DestroyWindow();
		}
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUdpclientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUdpclientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CUdpclientDlg::UpdateButton()
{
	GetDlgItem(IDOK)->EnableWindow(!m_connectflag);
	GetDlgItem(IDCANCEL)->EnableWindow(m_connectflag);
	GetDlgItem(IDC_SENDBUT)->EnableWindow(m_connectflag);
	GetDlgItem(IDC_SENDDATA)->EnableWindow(m_connectflag);
	GetDlgItem(IDC_COUNT)->EnableWindow(m_connectflag);	
}

void CUdpclientDlg::OnOK() 
{
	// TODO: Add extra validation here
	m_paravar.flag = 0;	
	UpdateData(TRUE);
	m_serip.GetAddress(m_ipvar);
	m_ipvar = htonl(m_ipvar);
	m_connectflag = 1;

	if ((m_sock = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) == INVALID_SOCKET) {
		CString	err;
        err.Format(IDS_SOCKERR,GetLastError());
        AfxMessageBox(err);		
		m_connectflag = 0;
	}
	m_sockinfo.sin_family = AF_INET;
	m_sockinfo.sin_port = htons((unsigned)atol(m_port));
	m_sockinfo.sin_addr.s_addr = m_ipvar;

	m_sockinfocli.sin_family = AF_INET;
	m_sockinfocli.sin_port = htons((unsigned)atol(m_port));
	m_sockinfocli.sin_addr.s_addr = htonl(INADDR_ANY);

	if ( bind( m_sock, (struct sockaddr *)&m_sockinfocli, sizeof(m_sockinfocli)) == SOCKET_ERROR ) {
		CString	err;
        err.Format(IDS_BINDERR,GetLastError());
        AfxMessageBox(err);		
		m_connectflag = 0;
	}

	UpdateButton();	
	if (m_connectflag != 0) {
		SetTimer(IDT_SENDDATA, 50, NULL);
		SetTimer(IDT_RECVDATA, 50, NULL);
		m_paravar.predit = (CEdit *)GetDlgItem(IDC_RECVDATA);
		m_psendthread = AfxBeginThread(SendPrg, this);
		m_precvthread = AfxBeginThread(RecvPrg, this);
	}
	//CDialog::OnOK();
}

void CUdpclientDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	m_paravar.flag |= ENDTHRD;
	closesocket(m_sock);
	m_connectflag = 0;
	m_senddata = "";
	m_paravar.data = m_senddata;
	m_paravar.dataidx = 0;
	m_paravar.flag = 0;	
	m_paravar.sendcnt = 0;	
	TerminateThread(m_psendthread->m_hThread,0);
	TerminateThread(m_precvthread->m_hThread,0);
	if(m_paravar.recvcnt != 0) {
		m_paravar.recvcnt = 0;
		m_paravar.predit->SetSel(0,-1);
		m_paravar.predit->ReplaceSel("");
	}
	m_paravar.predit = NULL;
	KillTimer(IDT_SENDDATA);
	KillTimer(IDT_RECVDATA);
	m_count = "1";
	m_paravar.butflag = 0;
	UpdateData(FALSE);
	UpdateButton();
	
	//CDialog::OnCancel();
}

void CUdpclientDlg::OnSendbut() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_paravar.butflag = 1;
	char	temp[10];
	wsprintf(temp,"%s",m_count);
	m_paravar.count = atol(temp);
	
}

void CUdpclientDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default

	if(nIDEvent == IDT_SENDDATA) {
		if (m_paravar.butflag == 1) {
			if (m_paravar.count == 0) {
				GetDlgItem(IDC_SENDDATA)->EnableWindow(TRUE);
				GetDlgItem(IDC_SENDBUT)->EnableWindow(TRUE);
				GetDlgItem(IDC_COUNT)->EnableWindow(TRUE);
				m_count = "1";
				m_paravar.butflag = 0;
			} else {
				GetDlgItem(IDC_SENDDATA)->EnableWindow(FALSE);
				GetDlgItem(IDC_SENDBUT)->EnableWindow(FALSE);
				GetDlgItem(IDC_COUNT)->EnableWindow(FALSE);
				m_senddata += m_defultdata;
				m_paravar.count--;
			}			
			UpdateData(FALSE);		
		}
		CEdit	*pedit;

		UpdateData(TRUE);				
		m_paravar.data = m_senddata;
		pedit = (CEdit *)GetDlgItem(IDC_SENDDATA);
		pedit->SetSel(32767,32767);
		if (m_paravar.flag & SENDERR) {
			CString	err;
			err.Format(IDS_SENDDATAERR,m_paravar.senderr);
			closesocket(m_sock);
			m_connectflag = 0;
			OnCancel();
			AfxMessageBox(err);
		}
	} else if (nIDEvent == IDT_RECVDATA) {
		if (m_paravar.flag & RECVERR) {
			CString	err;			
			err.Format(IDS_RECVDATAERR,m_paravar.recverr);
			closesocket(m_sock);
			m_connectflag = 0;
			OnCancel();
			AfxMessageBox(err);
		}				
	}
	
	CDialog::OnTimer(nIDEvent);
}

UINT	SendPrg(LPVOID pParam)
{
	CUdpclientDlg	*pDlg = (CUdpclientDlg *)pParam;

	DWORD	datalen;
	char*	pdata;
	DWORD	sendlen;
	DWORD	sendret;
		
	while(1) {
		if (pDlg->m_paravar.flag & ENDTHRD)
			break;
		datalen = pDlg->m_paravar.data.GetLength();
		sendlen = datalen - pDlg->m_paravar.dataidx;
		if (sendlen == 0) {
			Sleep(10);
			continue;
		}
		pdata = new char [datalen+1];
		strcpy(pdata,pDlg->m_paravar.data.GetBuffer(datalen));		
		pDlg->m_paravar.data.ReleaseBuffer(datalen);		
		sendret = 0;
		for(int i = 0 ; (unsigned)i < sendlen ; i++) {
			if ((sendret = sendto(pDlg->m_sock, &pdata[pDlg->m_paravar.dataidx], 1, 0, (struct sockaddr *)&pDlg->m_sockinfo, sizeof(pDlg->m_sockinfo))) == SOCKET_ERROR) {
				pDlg->m_paravar.senderr = GetLastError();
				pDlg->m_paravar.flag |= SENDERR;
				return	TRUE;
			}
			if (sendret > 0) {
				pDlg->m_paravar.sendcnt += sendret;
				pDlg->m_paravar.dataidx++;
			} else if (sendret == 0)
				i--;
			Sleep(8);
		}
		pDlg->m_paravar.dataidx = datalen;	
		delete [] pdata;
	}
	return	TRUE;
}

UINT	RecvPrg(LPVOID pParam)
{
	CUdpclientDlg	*pDlg = (CUdpclientDlg *)pParam;

	char	recvdata[1600];
	int		recvret;
	int		len;

	len = sizeof(pDlg->m_sockinfo);
	while(1) {
		if (pDlg->m_paravar.flag & ENDTHRD)
			break;
		if ((recvret = recvfrom(pDlg->m_sock, recvdata, 1600, 0, (struct sockaddr *)&pDlg->m_sockinfo, &len)) == SOCKET_ERROR) {
			if ((pDlg->m_paravar.recverr = GetLastError())!=WSAEWOULDBLOCK) {			
				pDlg->m_paravar.flag |= RECVERR;
				return	TRUE;
			}
		}
		if (recvret > 0) {
			if (recvdata[recvret-1] == NULL)
				pDlg->m_paravar.recvcnt += (recvret-1);					
			else {
				recvdata[recvret] = NULL;
				pDlg->m_paravar.recvcnt += recvret;
			}				
			if (pDlg->m_paravar.recvcnt < 27000) {
				pDlg->m_paravar.predit->SetSel(32767,32767);
				pDlg->m_paravar.predit->ReplaceSel(recvdata);
			}
		}		
	}	
	return	TRUE;
}
